/*******************************************************************************
*
*                    ATmega8 Timer 1 Servo
*                    ---------------------
*
*   Filename:                                    
*   Autor:                  David Kress
*
*   Version:                1.0
*   Date:                   06.08.2015
*   Built with:             ATMEL AVR Studio 4.14 and AVR-GCC; Optimization -01
*
*
*   Clock source:           - Any 4Mhz clock
*
*   Recommended             - High: 0xD9
*   Fuse settings:          - Low:  0xC3
*
*
*
*   Schematic:       ___________________
*                   |      ATMEGA16     |
*          Vcc ---->|Vcc                |
*          Vcc ---->|RESET              |
*                   |                   |
*          GND ---->|GND                |
*                   |                   |
*                   |               PB1 |----> DOUT     
*                   |                   |
*
*******************************************************************************/
#include <avr/io.h>

int main(void)
{

    DDRB = 0x02;                          // Setup PB1 as output
    

    ICR1 = 40000;                         // Set TOP to 40000 Frequency =
	                                      // 4MHZ / 40000 / 2 = 100Hz
										  // Phas e correct mode Periode is
										  // 2 * Timer Periode
    OCR1A = 3000;                         // Set Dutycycle
	                                      // 2000 => Pulse= 1ms    +90 deg
	                                      // 3000 => Pulse= 1.5ms   0  deg
	                                      // 4000 => Pulse= 2ms    -90 deg

	
	
    TCCR1A = (1<<WGM11)|(1<<COM1A1);     // Set Timer1 in Phase Correct Mode  
	                                     // with ICR1 as TOP value. Set OC1A
    TCCR1B = (1<<WGM13)|(1<<CS10);       // on compare match and clear OC1A 
	                                     // on BOTTOM. Clock Prescaler is 1
			  
			  
    

    for(;;);                             // Endless loop
                                         // main() will never be left
										 // Write Values to OCR1A ot turn
										 // The Servo

    return 0;                            // This line will never be executed
}


